﻿Carb = LibStub("AceAddon-3.0"):NewAddon("Broker_Carbonite", "AceEvent-3.0")
local Carb = Carb
local icon = "Interface\\Addons\\Broker_Carbonite\\icon.tga"

local menuTemplate = {
	{ text = "Carbonite", icon = icon, isTitle = true },
	{ text = "Help", func = function() Nx.Help:Open() end },
	{ text = "Options", func = function() Nx.Opts:Open() end },
	{ text = "Toggle Map", func = function() Nx.Map:ToggleSize(0) end },
	{ text = "Toggle Combat Graph", func = function() Nx.Combat:Open() end },
	{ text = "Toggle Events", func = function() Nx.UEvents.List:Open() end },
	{ text = "Toggle Favorites", func = function() Nx.Fav:ToggleShow() end },
	{ text = "Toggle Info 1 2", func = function() Nx.Info:ToggleShow()end },
	{ text = "Toggle Warehouse", func = function() Nx.Warehouse:ToggleShow() end },
	{ text = "Start Demo", func = function() Nx.Help.Demo:Start() end },
}

local menuFrame = CreateFrame("Frame", "Broker_CarboniteMenuFrame", UIParent, "UIDropDownMenuTemplate")

-- ACE Methods
function Carb:OnInitialize()
	NxData.NXGOpts["MapMMButShowCarb"] = false
end

-- Creating LDB plugin.
Carb.plugin = LibStub("LibDataBroker-1.1"):NewDataObject("Broker_Carbonite", {
						type = "data source",
						icon = icon,
						label = "Broker_Carbonite",
						text = "Carbonite",
						OnTooltipShow = function(tooltip)
											if not tooltip or not tooltip.AddLine then return end
											tooltip:AddLine("Carbonite")
											tooltip:AddLine("Left-Click to Toggle Map")
											if Nx.GetGlobalOpts()["MapMMButOwn"] then
												tooltip:AddLine("Shift Left-Click to Toggle Minimize")
											end
											tooltip:AddLine("Alt Left-Click to Toggle Watch List")
											tooltip:AddLine("Middle-Click to Toggle Guide")
											tooltip:AddLine("Right-Click for Menu")
										end,
						OnClick = function(frame, msg)
									if msg == "LeftButton" then
										if (IsShiftKeyDown()) then
											Nx.GetGlobalOpts()["MMButWinMinimize"] = not Nx.GetGlobalOpts()["MMButWinMinimize"]
											Nx.Map.Dock:UpdateOptions()
										elseif IsAltKeyDown() then
											Nx.Quest.Watch.Win:Show(not Nx.Quest.Watch.Win:IsShown())
										else
											Nx.Map:ToggleSize(0)
										end
									elseif msg == "MiddleButton" then
										Nx.Map:GetMap(1).Guide:ToggleShow()
									elseif msg == "RightButton" then
										EasyMenu(menuTemplate, menuFrame, "cursor", 0, 0, "MENU")
									end
								end,
						})

