﻿
-----------------------------------------------------------------
-- Database, bindings, and slash commands
-----------------------------------------------------------------

MeteorUIDB = {};
MeteorUIDB["HasBeenRun"] = 0;

SLASH_METEORUI1 = "/meteorui"
SlashCmdList["METEORUI"] = function()
	MeteorUI_Main:Show();
end

BINDING_HEADER_METEORUI = "MeteorUI";
BINDING_NAME_METEORUISHOW = "Configuration";



-----------------------------------------------------------------
-- OnLoad and Event declarations
-- (configured to open automatically when user logs in
-- until setup has been completed)
-----------------------------------------------------------------

function MeteorUI_Main_OnLoad()
	MeteorUI_Main:RegisterEvent("PLAYER_ENTERING_WORLD");
end

function MeteorUI_Main_OnEvent()
	if 	MeteorUIDB.HasBeenRun == 0 then
	   	MeteorUI_Main:Show();
	end
end



-----------------------------------------------------------------
-- Functions that are run when main window is opened/closed
-----------------------------------------------------------------

function MeteorUI_Main_OnShow()
	MeteorUI_Outline:Show();
end

function MeteorUI_Main_OnHide()
	MeteorUI_Outline:Hide();
end



-----------------------------------------------------------------
-- Primary functions that are run OnClick:
-- 1) Load settings common to all classes
-- 2) Load Class-specific settings
-- 3) Add savedvariable so it no longer auto-opens on login
-- 4) Reload the UI
-----------------------------------------------------------------

function DEATHKNIGHT_OnClick()
	Generic_Setup();
	DeathKnight_Setup();
	MeteorUIDB.HasBeenRun = 1;
	ReloadUI();
end

function DRUID_OnClick()
	Generic_Setup();
	Druid_Setup();
 	MeteorUIDB.HasBeenRun = 1;
 	ReloadUI();
end

function HUNTER_OnClick()
	Generic_Setup();
	Hunter_Setup();
	MeteorUIDB.HasBeenRun = 1;
	ReloadUI();
end

function MAGE_OnClick()
	Generic_Setup();
	Mage_Setup();
	MeteorUIDB.HasBeenRun = 1;
	ReloadUI();
end

function PALADIN_OnClick()
	Generic_Setup();
	Paladin_Setup();
	MeteorUIDB.HasBeenRun = 1;
	ReloadUI();
end

function PRIEST_OnClick()
	Generic_Setup();
	Priest_Setup();
	MeteorUIDB.HasBeenRun = 1;
	ReloadUI();
end

function ROGUE_OnClick()
	Generic_Setup();
	Rogue_Setup();
	MeteorUIDB.HasBeenRun = 1;
	ReloadUI();
end

function SHAMAN_OnClick()
	Generic_Setup();
	Shaman_Setup();
	MeteorUIDB.HasBeenRun = 1;
	ReloadUI();
end

function WARLOCK_OnClick()
	Generic_Setup();
	Warlock_Setup();
	MeteorUIDB.HasBeenRun = 1;
	ReloadUI();
end

function WARRIOR_OnClick()
	Generic_Setup();
	Warrior_Setup();
	MeteorUIDB.HasBeenRun = 1;
	ReloadUI();
end

function MONK_OnClick()
	Generic_Setup();
	Monk_Setup();
	MeteorUIDB.HasBeenRun = 1;
	ReloadUI();
end



-----------------------------------------------------------------
-- Generic settings common to all classes
-- (checks first if addon is loaded)
-----------------------------------------------------------------

function Generic_Setup()
	SetCVar("useuiScale", 1);
	SetCVar("uiScale", 0.64);
	SetCVar("enableCombatText", 0);
	SetCVar("CombatDamage", 0);
	SetCVar("CombatHealing", 0);
	SetCVar("fctSpellMechanics", 0);
	SetCVar("displaySpellActivationOverlays", 0);
	SetCVar("consolidateBuffs", 0);
	if IsAddOnLoaded("Recount") then
		Recount.db:SetProfile("Meteor");
	end
	if IsAddOnLoaded("Omen") then
		Omen.db:SetProfile("MeteorUI");
	end
	if IsAddOnLoaded("PitBull4") then
		PitBull4.db:SetProfile("MeteorUI");
	end
	if IsAddOnLoaded("Raven") then
		Raven.db:SetProfile("MeteorUI");
	end
	if IsAddOnLoaded("Castbars") then
		Castbars = LibStub("AceAddon-3.0"):GetAddon("Castbars",true);
		Castbars.db:SetProfile("MeteorUI");
	end
	if IsAddOnLoaded("Prat") then
		Prat.db:SetProfile("Paladin");
	end
	if IsAddOnLoaded("ShadowUF") then
		ShadowUF.db:SetProfile("MeteorUI");
	end
	if IsAddOnLoaded("Auditor2") then
		Auditor.db.profile.autoRepair = true;
		Auditor.db.realm.sellGreys = true;
	end
	if IsAddOnLoaded("SLDataText") then
		SLDataText = LibStub("AceAddon-3.0"):GetAddon("SLDataText",true);
		SLDataText.db:CopyProfile("MeteorUI");
	end
end



-----------------------------------------------------------------
-- Class-specific settings (currently unused)
-----------------------------------------------------------------

function DeathKnight_Setup()
	if IsAddOnLoaded("Bartender4") then
		Bartender4 = LibStub("AceAddon-3.0"):GetAddon("Bartender4",true);
		Bartender4.db:SetProfile("MeteorUI");
	end
end

function Druid_Setup()
	if IsAddOnLoaded("Bartender4") then
		Bartender4 = LibStub("AceAddon-3.0"):GetAddon("Bartender4",true);
		Bartender4.db:SetProfile("MeteorUI");
	end
end

function Hunter_Setup()
	if IsAddOnLoaded("Bartender4") then
		Bartender4 = LibStub("AceAddon-3.0"):GetAddon("Bartender4",true);
		Bartender4.db:SetProfile("MeteorUI");
	end
end

function Mage_Setup()
	if IsAddOnLoaded("Bartender4") then
		Bartender4 = LibStub("AceAddon-3.0"):GetAddon("Bartender4",true);
		Bartender4.db:SetProfile("MeteorUI");
	end
end

function Paladin_Setup()
	if IsAddOnLoaded("Bartender4") then
		Bartender4 = LibStub("AceAddon-3.0"):GetAddon("Bartender4",true);
		Bartender4.db:SetProfile("MeteorUI");
	end
end

function Priest_Setup()
	if IsAddOnLoaded("Bartender4") then
		Bartender4 = LibStub("AceAddon-3.0"):GetAddon("Bartender4",true);
		Bartender4.db:SetProfile("MeteorUI");
	end
end

function Rogue_Setup()
	if IsAddOnLoaded("Bartender4") then
		Bartender4 = LibStub("AceAddon-3.0"):GetAddon("Bartender4",true);
		Bartender4.db:SetProfile("MeteorUI");
	end
end

function Shaman_Setup()
	if IsAddOnLoaded("Bartender4") then
		Bartender4 = LibStub("AceAddon-3.0"):GetAddon("Bartender4",true);
		Bartender4.db:SetProfile("MeteorUI");
	end
end

function Warlock_Setup()
	if IsAddOnLoaded("Bartender4") then
		Bartender4 = LibStub("AceAddon-3.0"):GetAddon("Bartender4",true);
		Bartender4.db:SetProfile("MeteorUI");
	end
end

function Warrior_Setup()
	if IsAddOnLoaded("Bartender4") then
		Bartender4 = LibStub("AceAddon-3.0"):GetAddon("Bartender4",true);
		Bartender4.db:SetProfile("MeteorUI");
	end
end

function Monk_Setup()
	if IsAddOnLoaded("Bartender4") then
		Bartender4 = LibStub("AceAddon-3.0"):GetAddon("Bartender4",true);
		Bartender4.db:SetProfile("MeteorUI");
	end
end
