local AddonName, a = ...
if a.BuildFail(50000) then return end
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables

-- SpellFlash API:
-- http://wow.curseforge.com/addons/spellflash/pages/api/

-- Updated variable references:
-- http://wow.curseforge.com/addons/spellflash/pages/api/#w-local-x-spell-flash-addon-updated-variables
-- x.Enemy, x.ActiveEnemy, x.NoCC, x.InInstance, x.InstanceType, x.PetAlive, x.PetActiveEnemy, x.PetNoCC, x.Lag, x.DoubleLag, x.ThreatPercent, x.EnemyDetected, x.ShouldPermanentBuff, x.ShouldTemporaryBuff

-- Spell table references:
-- http://wow.curseforge.com/addons/spellflash/pages/api/#w-s-castable


a.spells["Defend"] = {
	Type = "vehicle",
	ID = 62552--[[Defend]],
	Buff = 62552--[[Defend]],
	BuffUnit = "vehicle",
	Stack = 3,
	EarlyRefresh = 15,
	NoRangeCheck = 1,
	GlobalVehicleCooldownSpell = 62575--[[Shield-Breaker]],
	Run = function(z)
		if s.InCombat() or ( s.Buff(62552--[[Defend]], "vehicle") and not s.Buff(62552--[[Defend]], "vehicle", 15) ) then
			z.FlashColor = "Yellow"
		else
			z.FlashColor = "Green"
		end
	end,
}

a.spells["Charge"] = {
	Type = "vehicle",
	ID = 62960--[[Charge]],
	EnemyTargetNeeded = 1,
	GlobalVehicleCooldownSpell = 62575--[[Shield-Breaker]],
	CheckFirst = function(z)
		z.FlashColor = s.If(x.ActiveEnemy, "White", "Pink")
		return x.NoCC and ( s.BuffStack(62552--[[Defend]]) <= 1 or s.EnemyTargetingYou() )
	end,
}

a.spells["Shield-Breaker"] = {
	Type = "vehicle",
	ID = 62575--[[Shield-Breaker]],
	EnemyTargetNeeded = 1,
	CheckFirst = function(z)
		z.FlashColor = s.If(x.ActiveEnemy, "White", "Pink")
		return x.NoCC
	end,
}

a.spells["Thrust"] = {
	Type = "vehicle",
	ID = 62544--[[Thrust]],
	EnemyTargetNeeded = 1,
	CheckFirst = function(z)
		z.FlashColor = s.If(x.ActiveEnemy, "White", "Pink")
		return x.NoCC
	end,
}

