local MinBuild, MaxBuild, Build = 40000, 0, select(4, GetBuildInfo())
if Build < MinBuild or ( MaxBuild > 0 and Build > MaxBuild ) then return end
local AddonName, a = ...
local L = a.Localize
local s = SpellFlashAddon
local x = SpellFlashAddon.UpdatedVariables

local function SetColor(UseColor, Color, ElseColor)
	if UseColor then
		return Color
	end
	return ElseColor or "Pink"
end

--[[
	White - Default
	Yellow - Limited Time or No Global Cooldown
	Purple - AOE or Positional Damage
	Blue - AOE Debuff
	Orange - Finishing Move
	Aqua - Spell Interrupt, Reflect or Dispel
	Green - Self Buff or Turn Autocast On
	Red - Emergency Mitigation Cooldowns or Turn Autocast Off
	Pink - Optional
]]

-- SpellFlash API: http://wow.curseforge.com/addons/spellflash/pages/api/
-- x.Enemy, x.ActiveEnemy, x.NoCC, x.InInstance, x.InstanceType, x.PetAlive, x.PetActiveEnemy, x.PetNoCC, x.Lag, x.DoubleLag, x.ThreatPercent, x.EnemyDetected, x.ShouldPermanentBuff, x.ShouldTemporaryBuff

--Teir 11
local StormridersBattlegarb372 = {
	HeadSlot = 65190--[[Stormrider's Headpiece]],
	ShoulderSlot = 65193--[[Stormrider's Spaulders]],
	ChestSlot = 65192--[[Stormrider's Raiment]],
	LegsSlot = 65191--[[Stormrider's Legguards]],
	HandsSlot = 65189--[[Stormrider's Grips]],
}
local StormridersBattlegarb359 = {
	HeadSlot = 60286--[[Stormrider's Headpiece]],
	ShoulderSlot = 60289--[[Stormrider's Spaulders]],
	ChestSlot = 60287--[[Stormrider's Raiment]],
	LegsSlot = 60288--[[Stormrider's Legguards]],
	HandsSlot = 60290--[[Stormrider's Grips]],
}


--Teir 13
local DeepEarthT13LFR = {
	HeadSlot = 78789--[[Deep Earth Headpiece]],
	ShoulderSlot = 78838--[[Deep Earth Spaulders]],
	ChestSlot = 78760--[[Deep Earth Raiment]],
	LegsSlot = 78808--[[Deep Earth Legguards]],
	HandsSlot = 78779--[[Deep Earth Grips]],
}
local DeepEarthT13 = {
	HeadSlot = 77015--[[Deep Earth Headpiece]],
	ShoulderSlot = 77017--[[Deep Earth Spaulders]],
	ChestSlot = 77013--[[Deep Earth Raiment]],
	LegsSlot = 77016--[[Deep Earth Legguards]],
	HandsSlot = 77014--[[Deep Earth Grips]],
}
local DeepEarthT13H = {
	HeadSlot = 78694--[[Deep Earth Headpiece]],
	ShoulderSlot = 78743--[[Deep Earth Spaulders]],
	ChestSlot = 78665--[[Deep Earth Raiment]],
	LegsSlot = 78713--[[Deep Earth Legguards]],
	HandsSlot = 78684--[[Deep Earth Grips]],
}


local function DeepEarthCount()
	local count = 0
	for Slot in pairs(DeepEarthT13) do
		if s.Equipped(DeepEarthT13LFR[Slot], Slot) or s.Equipped(DeepEarthT13[Slot], Slot) or s.Equipped(DeepEarthT13H[Slot], Slot) then
			count = count + 1
		end
	end
	return count
end

local function StormridersBattlegarbCount()
	local count = 0
	for Slot in pairs(StormridersBattlegarb372) do
		if s.Equipped(StormridersBattlegarb372[Slot], Slot) or s.Equipped(StormridersBattlegarb359[Slot], Slot) then
			count = count + 1
		end
	end
	return count
end
				
local function Buffs()
	if a.GetConfig("Disable_Buff") then return end
	if s.Flashable(1126--[[Mark of the Wild]]) and a.Castable["Mark of the Wild"]() then
		s.Flash(1126--[[Mark of the Wild]], "Green")
	end
end

local function CrowdControl()
	if a.GetConfig("Disable_CC") then return end
	if s.Flashable(2637--[[Hibernate]]) and a.Castable["Hibernate"]() then
		s.Flash(2637--[[Hibernate]], SetColor(x.ActiveEnemy, "Purple"))
	end
	if s.Flashable(339--[[Entangling Roots]]) and a.Castable["Entangling Roots"]() then
		s.Flash(339--[[Entangling Roots]], SetColor(x.ActiveEnemy, "Purple"))
	end
end

local function Survival()
	if a.GetConfig("Disable_Surv") then return end
		if s.TalentMastery(1) then
			if x.ThreatPercent >= 95 then
				if s.Flashable(16689--[[Nature's Grasp]]) and a.Castable["Entangling Roots"]() then
					s.Flash(16689--[[Nature's Grasp]], SetColor(x.ActiveEnemy, "Purple"))
				end
			end
		end
	if s.TalentMastery(2) then
		if s.Form(5487--[[Bear Form]]) then
			if s.HealthPercent("player") < 35 and s.Flashable(22842--[[Frenzied Regeneration]]) and x.NoCC and a.Castable["Frenzied Regeneration"]() then
				s.Flash(22842--[[Frenzied Regeneration]], SetColor(x.ActiveEnemy, "red"))
			end
			if x.ThreatPercent <= 95 then
				if s.Flashable(6795--[[Growl]]) and a.Castable["Entangling Roots"]() then
					s.Flash(6795--[[Growl]], SetColor(x.ActiveEnemy, "Purple"))
				elseif s.Flashable(5209--[[Challenging Roar]]) and a.Castable["Entangling Roots"]() then
					s.Flash(5209--[[Challenging Roar]], SetColor(x.ActiveEnemy, "Purp le"))
				end
			end
			
				if s.Boss() and s.Flashable(22812--[[Barkskin]]) and x.NoCC and s.Boss() and s.HealthPercent("player") < 50 and a.Castable["Barkskin"]() then
					s.Flash(22812--[[Barkskin]], SetColor(x.ActiveEnemy, "Red"))
				elseif s.Flashable(61336--[[Survival Instincts]]) and x.NoCC and s.HealthPercent("player") < 35 and a.Castable["Survival Instincts"]() then
					s.Flash(61336--[[Survival Instincts]], SetColor(x.ActiveEnemy, "Red"))
				elseif s.Flashable(22812--[[Barkskin]]) and x.NoCC and s.HealthPercent("player") < 40 and a.Castable["Barkskin"]() then
					s.Flash(22812--[[Barkskin]], SetColor(x.ActiveEnemy, "Red"))
				end	
		end
		if s.Form(768--[[Cat Form]]) then
			if x.ThreatPercent >= 95 and ( GetNumRaidMembers() > 1 or GetNumPartyMembers() > 0 ) then
				if s.Flashable(8998--[[Cower]]) and x.NoCC and a.Castable["Cower"]() then
					s.Flash(8998--[[Cower]], SetColor(x.ActiveEnemy, "Purple"))
				elseif s.Flashable(16689--[[Nature's Grasp]]) and a.Castable["Entangling Roots"]() then
					s.Flash(16689--[[Nature's Grasp]], SetColor(x.ActiveEnemy, "Purple"))
				end
			end
			if s.Flashable(61336--[[Survival Instincts]]) and x.NoCC and s.HealthPercent("player") < 20 and a.Castable["Survival Instincts"]() then
				s.Flash(61336--[[Survival Instincts]], SetColor(x.ActiveEnemy, "Red"))
			elseif s.Flashable(22812--[[Barkskin]]) and x.NoCC and s.HealthPercent("player") < 20 and a.Castable["Barkskin"]() then
				s.Flash(22812--[[Barkskin]], SetColor(x.ActiveEnemy, "Red"))
			end
		end
	end
end

local function ManaRegen()
	if a.GetConfig("Disable_Mana") then return end
		if not s.Form(768--[[Cat Form]]) or s.Form(5487--[[Bear Form]]) then
			if s.Flashable(29166--[[Innervate]]) and x.NoCC and s.PowerPercent("player") < 70 and not s.TalentMastery(2) and a.Castable["Innervate"]() then
				s.Flash(29166--[[Innervate]], SetColor(x.ActiveEnemy, "Aqua"))
			end
		end
end
local function Interrupts()
	if a.GetConfig("Disable_Kick") then return end
		if s.TalentMastery(1) then
			if s.Flashable(78675--[[Solar Beam]]) and x.NoCC and a.Castable["Solar Beam"]() then
				s.Flash(78675--[[Solar Beam]], SetColor(x.ActiveEnemy, "Aqua"))
			end
		end
		if s.TalentMastery(2) then
			if s.Form(5487--[[Bear Form]]) then
				if s.Flashable(80964--[[Skull Bash(Bear Form)]]) and x.NoCC and a.Castable["Skull Bash(Bear Form)"]() then
					s.Flash(80964--[[Skull Bash(Bear Form)]], SetColor(x.ActiveEnemy, "Aqua"))
				elseif s.Flashable(5211--[[Bash]]) and x.NoCC and a.Castable["Bash"]() then
					s.Flash(5211--[[Bash]], SetColor(x.ActiveEnemy, "Aqua"))
				end
			end
			if s.Form(768--[[Cat Form]]) then
				if s.Flashable(80965--[[Skull Bash(Cat Form)]]) and x.NoCC and a.Castable["Skull Bash(Cat Form)"]() then
					s.Flash(80965--[[Skull Bash(Cat Form)]], SetColor(x.ActiveEnemy, "Aqua"))
				end
			end
		end
end

local function Stance()
	if not a.GetConfig("Disable_Stance") then return end
	
		if s.TalentMastery(1) then
			if s.HasTalent(24858--[[Moonkin Form]]) and a.Castable["Moonkin Form"]() then
				if s.Flashable(24858--[[Moonkin Form]]) then
					s.Flash(24858--[[Moonkin Form]])
				end
				s.FlashForm(24858--[[Moonkin Form]])
			end
		end
		
		if s.TalentMastery(2) then
			if s.HasTalent(16929--[[Thick Hide]]) and a.Castable["Bear Form"]() then
				if s.Flashable(5487--[[Bear Form]]) then
					s.Flash(5487--[[Bear Form]])
				end
				s.FlashForm(5487--[[Bear Form]])
			elseif a.Castable["Cat Form"]() then
				if s.Flashable(768--[[Cat Form]]) then
					s.Flash(768--[[Cat Form]])
				end
				s.FlashForm(768--[[Cat Form]])
			end
		end
		
end

local function CatRotation()
	if a.GetConfig("Disable_Cat") then return end
		if s.TalentMastery(2) then
			if s.Form(768--[[Cat Form]]) then
			
		local MangleAndBloodFrenzy = s.Debuff(29859--[[Blood Frenzy]]) or s.Debuff(33876--[[Mangle]])
		
		local StormridersBattlegarbPieces = StormridersBattlegarbCount()
		local FourStormridersBattlegarbPieces = StormridersBattlegarbPieces >= 4
		local TwoStormridersBattlegarbPieces = StormridersBattlegarbPieces >= 2
		
		local DeepEarthPieces = DeepEarthCount()
		local FourDeepEarthPieces = DeepEarthPieces >= 4
		local TwoDeepEarthPieces = DeepEarthPieces >= 2
				
				if s.Flashable(16857--[[Faerie Fire (Feral)]]) and x.NoCC and a.Castable["Faerie Fire (Feral)"]() then
					s.Flash(16857--[[Faerie Fire (Feral)]], SetColor(x.ActiveEnemy))
				end
				if s.Flashable(49376--[[Feral Charge(Cat Form)]]) and x.NoCC and a.Castable["Feral Charge(Cat Form)"]() then
					s.Flash(49376--[[Feral Charge(Cat Form)]], SetColor(x.ActiveEnemy))
				end
				
				
					if s.Flashable(6785--[[Ravage]]) and x.NoCC and a.Castable["Ravage"]() then
						s.Flash(6785--[[Ravage]], SetColor(x.ActiveEnemy, "Yellow"))
					end
					if s.Flashable(81170--[[Ravage!]]) and x.NoCC and a.Castable["Ravage"]() then
						s.Flash(81170--[[Ravage!]], SetColor(x.ActiveEnemy, "Yellow"))
					end
					
				
				if s.Flashable(5217--[[Tiger's Fury]]) and x.NoCC and s.PowerPercent("player") < 25 and GetComboPoints("player") <= 4 and a.Castable["Tiger's Fury"]() then
					s.Flash(5217--[[Tiger's Fury]], SetColor(x.ActiveEnemy, "Green"))
				else
					local TFCooldownRemaining, TFCooldownDuration = s.SpellCooldown(5217--[[Tiger's Fury]])
					local TFOnCooldown = TFCooldownRemaining > x.Lag and TFCooldownDuration > 1.5
					if s.Flashable(50334--[[Berserk]]) and x.NoCC and TFOnCooldown and ( TFCooldownRemaining > 15 or ( TFCooldownRemaining > 20 and s.HasGlyph(64268--[[Glyph of Berserk]]) ) ) and s.PowerPercent("player") > 69 and a.Castable["Berserk"]() then
						s.Flash(50334--[[Berserk]], SetColor(x.ActiveEnemy, "Green"))
					end
				end
				
				--local TFCooldownRemaining, TFCooldownDuration = s.SpellCooldown(5217--[[Tiger's Fury]])
				--if s.Flashable(5217--[[Tiger's Fury]]) and x.NoCC and s.PowerPercent("player") < 25 and a.Castable["Tiger's Fury"]() then
					--s.Flash(5217--[[Tiger's Fury]], SetColor(x.ActiveEnemy, "Green"))
				--elseif s.Flashable(50334--[[Berserk]]) and TFCooldownRemaining < 15 and TFCooldownRemaining > x.Lag and TFCooldownDuration > 1.5 and x.NoCC and s.PowerPercent("player") > 69 and a.Castable["Berserk"]() then
					--s.Flash(50334--[[Berserk]], SetColor(x.ActiveEnemy, "Green"))
				--elseif s.Flashable(50334--[[Berserk]]) and s.HasGlyph(45601--[[Glyph of Berserk]]) and TFCooldownRemaining < 20 and TFCooldownRemaining > x.Lag and TFCooldownDuration > 1.5 and x.NoCC and s.PowerPercent("player") > 69 and a.Castable["Berserk"]() then
					--s.Flash(50334--[[Berserk]], SetColor(x.ActiveEnemy, "Green"))
				--end
				
				--elseif s.Flashable(50334--[[Berserk]]) and s.PowerPercent("player") > 69 and s.HasGlyph(45601--[[Glyph of Berserk]]) and s.SpellCooldown(5217--[[Tiger's Fury]]) < 20 and x.NoCC and a.Castable["Berserk"]() then
					--s.Flash(50334--[[Berserk]], SetColor(x.ActiveEnemy, "Green"))
				--elseif s.Flashable(50334--[[Berserk]]) and s.SpellCooldown(5217--[[Tiger's Fury]]) > 0 and s.PowerPercent("player") > 80 and x.NoCC and a.Castable["Berserk"]() then
					--s.Flash(50334--[[Berserk]], SetColor(x.ActiveEnemy, "Green"))
		
				if not TwoDeepEarthPieces and s.HealthPercent("target") < 25 and s.HasTalent(80319--[[Blood in the Water]]) and s.MyDebuff(1079--[[Rip]]) then
					if not s.MyDebuffDuration(1079--[[Rip]], nil, 5) and GetComboPoints("player") >= 1 then
						if x.NoCC and s.Flashable(22568--[[Ferocious Bite]]) and a.Castable["Ferocious Bite"]() then
							s.Flash(22568--[[Ferocious Bite]], SetColor(x.ActiveEnemy, "Red"))
						end
					elseif s.MyDebuff(1079--[[Rip]]) and GetComboPoints("player") == 5 then
						if x.NoCC and s.Flashable(22568--[[Ferocious Bite]]) and a.Castable["Ferocious Bite"]() then
							s.Flash(22568--[[Ferocious Bite]], SetColor(x.ActiveEnemy, "Red"))
						end
					end
				end
				--Tier 13 2 Piece set
				if TwoDeepEarthPieces and s.HealthPercent("target") < 60 and s.HasTalent(80319--[[Blood in the Water]]) and s.MyDebuff(1079--[[Rip]]) then
					if not s.MyDebuffDuration(1079--[[Rip]], nil, 5) and GetComboPoints("player") >= 1 then
						if x.NoCC and s.Flashable(22568--[[Ferocious Bite]]) and a.Castable["Ferocious Bite"]() then
							s.Flash(22568--[[Ferocious Bite]], SetColor(x.ActiveEnemy, "Red"))
						end
					elseif s.MyDebuff(1079--[[Rip]]) and GetComboPoints("player") == 5 then
						if x.NoCC and s.Flashable(22568--[[Ferocious Bite]]) and a.Castable["Ferocious Bite"]() then
							s.Flash(22568--[[Ferocious Bite]], SetColor(x.ActiveEnemy, "Red"))
						end
					end
				end
				
				if FourStormridersBattlegarbPieces and s.MyDebuff(1822--[[Rake]]) then
					if s.Flashable(33876--[[Mangle(Cat Form)]]) and x.NoCC and s.BuffStack(90166--[[Strength of the Panther]], "player") <= 2 and a.Castable["Mangle(Cat Form)"]() then
						s.Flash(33876--[[Mangle(Cat Form)]], SetColor(x.ActiveEnemy, "Green"))
					elseif s.Flashable(33876--[[Mangle(Cat Form)]]) and x.NoCC and s.BuffDuration(90166--[[Strength of the Panther]], "player", 5) and a.Castable["Mangle(Cat Form)"]() then
						s.Flash(33876--[[Mangle(Cat Form)]], SetColor(x.ActiveEnemy, "Green"))
					end
				end
				
				
				
				if s.Buff(32182--[[Heroism]], "player") or s.Buff(2825--[[Bloodlust]], "player") or s.Buff(80353--[[Time Warp]], "player") then
					if s.Flashable(s.ItemName(58145--[[Potion of the Tol'vir]])) and x.NoCC and a.ItemCastable["Potion of the Tol'vir"]() then
						s.Flash(s.ItemName(58145--[[Potion of the Tol'vir]], SetColor(x.ActiveEnemy, "Green")))
					end
				end
				
				if a.NotBehind then -- Not Behind
					
					if s.Flashable(1079--[[Rip]]) and x.NoCC and GetComboPoints("player") == 5 and ( s.Boss() or s.HealthPercent() > 10 ) and a.Castable["Rip"]() then
						s.Flash(1079--[[Rip]], SetColor(x.ActiveEnemy, "Yellow"))
					--elseif s.Flashable(22568--[[Ferocious Bite]]) and s.MyDebuff(50334--[[Berserk]]) and x.NoCC and GetComboPoints("player") == 5 and a.Castable["Ferocious Bite"]() then
						--s.Flash(22568--[[Ferocious Bite]], SetColor(x.ActiveEnemy, "Yellow"))
					elseif s.Flashable(33876--[[Mangle(Cat Form)]]) and x.NoCC and not FourStormridersBattlegarbPieces and s.DebuffDuration(33876--[[Mangle(Cat Form)]], nil, 5) and a.Castable["Mangle(Cat Form)2"]() then
						s.Flash(33876--[[Mangle(Cat Form)]], SetColor(x.ActiveEnemy, "Yellow"))
					elseif s.Flashable(1822--[[Rake]]) and x.NoCC and a.Castable["Rake"]() then
						s.Flash(1822--[[Rake]], SetColor(x.ActiveEnemy, "Yellow"))
					elseif s.Flashable(52610--[[Savage Roar]]) and x.NoCC and s.MyDebuff(1079--[[Rip]]) and s.PowerPercent("player") > 30 and GetComboPoints("player") < 2 and s.BuffDuration(52610--[[Savage Roar]], nil, 5) and a.Castable["Savage Roar"]() then
						s.Flash(52610--[[Savage Roar]], SetColor(x.ActiveEnemy, "Green"))
					elseif s.Flashable(52610--[[Savage Roar]]) and s.MyDebuff(1079--[[Rip]], nil, 8) and x.NoCC and a.Castable["Savage Roar"]() then
						s.Flash(52610--[[Savage Roar]], SetColor(x.ActiveEnemy, "Green"))
					end
						
					if s.MyDebuff(1822--[[Rake]]) then
						if x.ThreatPercent >= 95 then
							if s.Flashable(33876--[[Mangle(Cat Form)]]) and x.NoCC and GetComboPoints("player") <= 4 and a.Castable["Mangle(Cat Form)"]() then
								s.Flash(33876--[[Mangle(Cat Form)]], SetColor(x.ActiveEnemy, "Purple"))
							end
						elseif s.Flashable(33876--[[Mangle(Cat Form)]]) and x.NoCC and s.Buff(16870--[[Clearcasting]], "player") and a.Castable["Mangle(Cat Form)"]() then
							s.Flash(33876--[[Mangle(Cat Form)]], SetColor(x.ActiveEnemy, "Green"))
						elseif s.Flashable(33876--[[Mangle(Cat Form)]]) and x.NoCC and s.Buff(50334--[[Berserk]], "player") and a.Castable["Mangle(Cat Form)"]() then
							s.Flash(33876--[[Mangle(Cat Form)]], SetColor(x.ActiveEnemy, "Yellow"))
						elseif s.Flashable(33876--[[Mangle(Cat Form)]]) and x.NoCC and GetComboPoints("player") <= 4 and a.Castable["Mangle(Cat Form)"]() then
							s.Flash(33876--[[Mangle(Cat Form)]], SetColor(x.ActiveEnemy))
						elseif s.Flashable(33876--[[Mangle(Cat Form)]]) and s.PowerPercent("player") > 70 and x.NoCC and a.Castable["Mangle(Cat Form)"]() then
							s.Flash(33876--[[Mangle(Cat Form)]], SetColor(x.ActiveEnemy))
						elseif not s.TalentMastery(2) and x.NoCC and s.Flashable(1082--[[Claw]]) and a.Castable["Claw"]() then
							s.Flash(1082--[[Claw]], SetColor(x.ActiveEnemy, "Purple"))
						end
					end
					
				else -- Behind
					
					if s.Flashable(1079--[[Rip]]) and x.NoCC and GetComboPoints("player") == 5 and ( s.Boss() or s.HealthPercent() > 10 ) and a.Castable["Rip"]() then
						s.Flash(1079--[[Rip]], SetColor(x.ActiveEnemy, "Yellow"))
					--elseif s.Flashable(22568--[[Ferocious Bite]]) and s.MyDebuff(50334--[[Berserk]]) and x.NoCC and GetComboPoints("player") == 5 and a.Castable["Ferocious Bite"]() then
						--s.Flash(22568--[[Ferocious Bite]], SetColor(x.ActiveEnemy, "Yellow"))
					elseif s.Flashable(33876--[[Mangle(Cat Form)]]) and x.NoCC and not FourStormridersBattlegarbPieces and s.DebuffDuration(33876--[[Mangle(Cat Form)]], nil, 5) and a.Castable["Mangle(Cat Form)2"]() then
						s.Flash(33876--[[Mangle(Cat Form)]], SetColor(x.ActiveEnemy, "Yellow"))
					elseif s.Flashable(1822--[[Rake]]) and x.NoCC and a.Castable["Rake"]() then
						s.Flash(1822--[[Rake]], SetColor(x.ActiveEnemy, "Yellow"))
					elseif s.Flashable(52610--[[Savage Roar]]) and x.NoCC and s.MyDebuff(1079--[[Rip]]) and s.PowerPercent("player") > 30 and GetComboPoints("player") < 2 and s.BuffDuration(52610--[[Savage Roar]], nil, 5) and a.Castable["Savage Roar"]() then
						s.Flash(52610--[[Savage Roar]], SetColor(x.ActiveEnemy, "Green"))
					elseif s.Flashable(52610--[[Savage Roar]]) and s.MyDebuff(1079--[[Rip]], nil, 8) and x.NoCC and a.Castable["Savage Roar"]() then
						s.Flash(52610--[[Savage Roar]], SetColor(x.ActiveEnemy, "Green"))
					end
						
					if (s.Debuff(33876--[[Mangle(Cat Form)]]) or s.Debuff(33878--[[Mangle]]) or s.Debuff(46856--[[Trauma]]) or s.Debuff(16511--[[Hemorrhage]])) and s.MyDebuff(1822--[[Rake]]) then
						if x.ThreatPercent >= 95 then
							if s.Flashable(33876--[[Mangle(Cat Form)]]) and x.NoCC and GetComboPoints("player") <= 4 and a.Castable["Mangle(Cat Form)"]() then
								s.Flash(33876--[[Mangle(Cat Form)]], SetColor(x.ActiveEnemy, "Purple"))
							end
						elseif s.Flashable(5221--[[Shred]]) and x.NoCC and s.Buff(16870--[[Clearcasting]], "player") and a.Castable["Shred"]() then
							s.Flash(5221--[[Shred]], SetColor(x.ActiveEnemy, "Green"))
						elseif s.Flashable(5221--[[Shred]]) and x.NoCC and s.Buff(50334--[[Berserk]], "player") and a.Castable["Shred"]() then
							s.Flash(5221--[[Shred]], SetColor(x.ActiveEnemy, "Yellow"))
						elseif s.Flashable(5221--[[Shred]]) and x.NoCC and GetComboPoints("player") <= 4 and a.Castable["Shred"]() then
							s.Flash(5221--[[Shred]], SetColor(x.ActiveEnemy))
						elseif s.Flashable(5221--[[Shred]]) and s.PowerPercent("player") > 70 and x.NoCC and a.Castable["Shred"]() then
							s.Flash(5221--[[Shred]], SetColor(x.ActiveEnemy))
						elseif not s.TalentMastery(2) and x.NoCC and s.Flashable(1082--[[Claw]]) and a.Castable["Claw"]() then
							s.Flash(1082--[[Claw]], SetColor(x.ActiveEnemy, "Purple"))
						end
					end
					
				end
				
			end
			
		end
end

local function BearRotation()
	if a.GetConfig("Disable_Bear") then return end
		if s.TalentMastery(2) then
		
		local StormridersBattlegarbPieces = StormridersBattlegarbCount()
		local FourStormridersBattlegarbPieces = StormridersBattlegarbPieces >= 4
		local TwoStormridersBattlegarbPieces = StormridersBattlegarbPieces >= 2
		
		local DeepEarthPieces = DeepEarthCount()
		local FourDeepEarthPieces = DeepEarthPieces >= 4
		local TwoDeepEarthPieces = DeepEarthPieces >= 2
			
			if s.Form(5487--[[Bear Form]]) then
				
				if s.Flashable(50334--[[Berserk]]) and s.MyBuff(80313--[[Pulverize]], "player") and (s.MyDebuffStack(91565--[[Faerie Fire]]) == 3 or s.MyDebuffStack(7386--[[Sunder Armor]]) == 3)and x.NoCC and a.Castable["Berserk"]() then
					s.Flash(50334--[[Berserk]], SetColor(x.ActiveEnemy, "Green"))
				end
				if s.Flashable(16979--[[Feral Charge(Bear Form)]]) and x.NoCC and a.Castable["Feral Charge(Bear Form)"]() then
					s.Flash(16979--[[Feral Charge(Bear Form)]], SetColor(x.ActiveEnemy))
				end
				if s.Flashable(5229--[[Enrage]]) and x.NoCC and s.PowerPercent("player") < 50 and a.Castable["Enrage"]() then
					s.Flash(5229--[[Enrage]], SetColor(x.ActiveEnemy))
				end
				
				if s.Flashable(99--[[Demoralizing Roar]]) and x.NoCC and a.Castable["Demoralizing Roar"]() then
					s.Flash(99--[[Demoralizing Roar]], SetColor(x.ActiveEnemy, "Orange"))
				end
				
				if s.Buff(50334--[[Berserk]], "player") then
					
					if s.Flashable(6807--[[Maul]]) and x.NoCC and (s.PowerPercent("player") > 65 or s.Buff(16870--[[Clearcasting]], "player")) and a.Castable["Maul"]() then
						s.Flash(6807--[[Maul]], SetColor(x.ActiveEnemy))
					elseif s.Flashable(6807--[[Maul]]) and x.NoCC and s.PowerPercent("player") > 45 and s.MyDebuffStack(33745--[[Lacerate]]) > 0 and s.MyDebuff(77758--[[Thrash]]) and a.Castable["Maul"]() then
						s.Flash(6807--[[Maul]], SetColor(x.ActiveEnemy))
					end
					if s.Flashable(33878--[[Mangle(Bear Form)]]) and x.NoCC and a.Castable["Mangle(Bear Form)"]() then
						s.Flash(33878--[[Mangle(Bear Form)]], SetColor(x.ActiveEnemy, "Yellow"))
					end
				end
				
				if not s.Buff(50334--[[Berserk]], "player") and not TwoDeepEarthPieces then
					if s.Flashable(6807--[[Maul]]) and x.NoCC and (s.PowerPercent("player") > 65 or s.Buff(16870--[[Clearcasting]], "player")) and a.Castable["Maul"]() then
						s.Flash(6807--[[Maul]], SetColor(x.ActiveEnemy))
					elseif s.Flashable(6807--[[Maul]]) and x.NoCC and s.PowerPercent("player") > 45 and s.MyDebuffStack(33745--[[Lacerate]]) > 0 and s.MyDebuff(77758--[[Thrash]]) and a.Castable["Maul"]() then
						s.Flash(6807--[[Maul]], SetColor(x.ActiveEnemy))
					end
	
					if s.Flashable(33878--[[Mangle(Bear Form)]]) and x.NoCC and a.Castable["Mangle(Bear Form)"]() then
						s.Flash(33878--[[Mangle(Bear Form)]], SetColor(x.ActiveEnemy))
					elseif s.Flashable(77758--[[Thrash]]) and x.NoCC and a.Castable["Thrash"]() then
						s.Flash(77758--[[Thrash]], SetColor(x.ActiveEnemy, "Purple"))
					elseif s.Flashable(16857--[[Faerie Fire (Feral)]]) and x.NoCC and a.Castable["Faerie Fire (Feral)"]() then
						s.Flash(16857--[[Faerie Fire (Feral)]], SetColor(x.ActiveEnemy))
					elseif s.Flashable(80313--[[Pulverize]]) and x.NoCC and s.MyDebuffStack(33745--[[Lacerate]]) == 3 and not s.Buff(80313--[[Pulverize]], "player") and a.Castable["Pulverize"]() then
						s.Flash(80313--[[Pulverize]], SetColor(x.ActiveEnemy, "Green"))
					elseif s.Flashable(33745--[[Lacerate]]) and x.NoCC and s.MyDebuffStack(33745--[[Lacerate]]) < 3 and s.SpellCooldown(77758--[[Thrash]]) > 0 and a.Castable["Lacerate"]() then
						s.Flash(33745--[[Lacerate]], SetColor(x.ActiveEnemy))
					end
				end
				
			if not s.Buff(50334--[[Berserk]], "player") and TwoDeepEarthPieces then
					if s.Flashable(6807--[[Maul]]) and x.NoCC and (s.PowerPercent("player") > 65 or s.Buff(16870--[[Clearcasting]], "player")) and a.Castable["Maul"]() then
						s.Flash(6807--[[Maul]], SetColor(x.ActiveEnemy))
					elseif s.Flashable(6807--[[Maul]]) and x.NoCC and s.PowerPercent("player") > 45 and s.MyDebuffStack(33745--[[Lacerate]]) > 0 and s.MyDebuff(77758--[[Thrash]]) and a.Castable["Maul"]() then
						s.Flash(6807--[[Maul]], SetColor(x.ActiveEnemy))
					end
	
					if s.Flashable(33878--[[Mangle(Bear Form)]]) and x.NoCC and a.Castable["Mangle(Bear Form)"]() then
						s.Flash(33878--[[Mangle(Bear Form)]], SetColor(x.ActiveEnemy))
					elseif s.Flashable(80313--[[Pulverize]]) and x.NoCC and s.MyDebuffStack(33745--[[Lacerate]]) == 3 and not s.Buff(80313--[[Pulverize]], "player") and a.Castable["Pulverize"]() then
						s.Flash(80313--[[Pulverize]], SetColor(x.ActiveEnemy, "Green"))
					elseif s.Flashable(77758--[[Thrash]]) and x.NoCC and a.Castable["Thrash"]() then
						s.Flash(77758--[[Thrash]], SetColor(x.ActiveEnemy, "Purple"))
					elseif s.Flashable(16857--[[Faerie Fire (Feral)]]) and x.NoCC and a.Castable["Faerie Fire (Feral)"]() then
						s.Flash(16857--[[Faerie Fire (Feral)]], SetColor(x.ActiveEnemy))
					elseif s.Flashable(33745--[[Lacerate]]) and x.NoCC and s.MyDebuffStack(33745--[[Lacerate]]) < 3 and s.SpellCooldown(77758--[[Thrash]]) > 0 and a.Castable["Lacerate"]() then
						s.Flash(33745--[[Lacerate]], SetColor(x.ActiveEnemy))
					end
				end
			end
		end
end

local function BoomkinRotation()
	if a.GetConfig("Disable_Boomkin") then return end
		if s.TalentMastery(1) then
			
			if s.Boss("target") and (s.Buff(32182--[[Heroism]]) or s.Buff(2825--[[Bloodlust]]) or s.Buff(80353--[[Time Warp]])) then
				if s.Flashable(33831--[[Force of Nature]]) and x.NoCC and a.Castable["Force of Nature"]() then
					s.Flash(33831--[[Force of Nature]], SetColor(x.ActiveEnemy, "Yellow"))
				end
			end
			
			if s.Flashable(5570--[[Insect Swarm]]) and x.NoCC and a.Castable["Insect Swarm"]() then
				s.Flash(5570--[[Insect Swarm]], SetColor(x.ActiveEnemy))
			end
			
			if ( s.Flashable(8921--[[Moonfire]]) or s.Flashable(93402--[[Sunfire]]) ) and x.NoCC and a.Castable["Moonfire"]() then
				s.Flash(8921--[[Moonfire]], SetColor(x.ActiveEnemy))
				s.Flash(93402--[[Sunfire]], SetColor(x.ActiveEnemy))
			end
			
			if s.Form(24858--[[Moonkin Form]]) then
				--if s.Flashable(48505--[[Starfall]]) and s.Buff(48518--[[Eclipse (Lunar)]], "player") and x.NoCC and a.Castable["Starfall"]() then
					--s.Flash(48505--[[Starfall]], SetColor(x.ActiveEnemy))
				if s.Flashable(33831--[[Force of Nature]]) and x.NoCC and s.MyDebuff(5570--[[Insect Swarm]]) and ( s.MyDebuff(8921--[[Moonfire]]) or s.MyDebuff(93402--[[Sunfire]]) ) and a.Castable["Force of Nature"]() then
					s.Flash(33831--[[Force of Nature]], SetColor(x.ActiveEnemy, "Yellow"))
				elseif s.Flashable(78674--[[Starsurge]]) and x.NoCC and a.Castable["Starsurge"]() then
					s.Flash(78674--[[Starsurge]], SetColor(x.ActiveEnemy))
				elseif s.Flashable(2912--[[Starfire]]) and x.NoCC and s.Buff(48518--[[Eclipse (Lunar)]], "player") and a.Castable["Starfire"]() then
					s.Flash(2912--[[Starfire]], SetColor(x.ActiveEnemy))
				elseif s.Flashable(5176--[[Wrath]]) and x.NoCC and s.Buff(48517--[[Eclipse (Solar)]], "player") and a.Castable["Wrath"]() then
					s.Flash(5176--[[Wrath]], SetColor(x.ActiveEnemy))
				elseif s.Flashable(2912--[[Starfire]]) and x.NoCC and s.Power("player", SPELL_POWER_ECLIPSE) >= 0 and not s.Buff(48517--[[Eclipse (Solar)]], "player") and a.Castable["Starfire"]() then
					s.Flash(2912--[[Starfire]], SetColor(x.ActiveEnemy))
				elseif s.Flashable(5176--[[Wrath]]) and x.NoCC and s.Power("player", SPELL_POWER_ECLIPSE) < 0 and not s.Buff(48518--[[Eclipse (Lunar)]], "player") and a.Castable["Wrath"]() then
					s.Flash(5176--[[Wrath]], SetColor(x.ActiveEnemy))
				end
			end
		end
end

local function RestoProc()
	if a.GetConfig("Disable_Resto") then return end
		if s.TalentMastery(3) then

		end
end

local function TrashRotation()
	if not a.GetConfig("Enable_Trash") then return end
		local t4cat = (s.BuffStack(90166--[[Strength of the Panther]]) <= 2 or s.BuffDuration(90166--[[Strength of the Panther]], nil, 5))
		
end

-- Use this single spam function and remove the multiple spam table below, or just use the multiple spam table below and leave this function in place.
s.Spam[AddonName] = function() if a.GetConfig("spell_flashing_off") then return end a.RunSpamTable()
	
		
		
		CrowdControl()
		Survival()
		ManaRegen()
		Interrupts()
		TrashRotation()
		Buffs()
		Stance()
		RestoProc()
		BoomkinRotation()
		BearRotation()
		CatRotation()
	
end

