local MinBuild, MaxBuild, Build = 40000, 0, select(4, GetBuildInfo())
if Build < MinBuild or ( MaxBuild > 0 and Build > MaxBuild ) then return end
local AddonName, a = ...
local AddonTitle = select(2, GetAddOnInfo(AddonName))
local PlainAddonTitle = AddonTitle:gsub("|c........", ""):gsub("|r", "")
local L = a.Localize
local s = SpellFlashAddon
local x = SpellFlashAddon.UpdatedVariables
local config = {}
config.event = {}


-- Only add this function if a spell has a buff or debuff name that is different than the name of the spell that is cast.
-- This is so travel time can be properly tracked for the spell.
-- Example other auras function:
function config.OtherAurasFunction()
	if s.HasTalent(12873--[[Critical Mass]]) then
		s.SetOtherAuras(2948--[[Scorch]], 11095--[[Critical Mass]])
		s.SetOtherAuras(11366--[[Pyroblast]], 11095--[[Critical Mass]])
		end
--	if s.HasTalent(32385--[[Shadow Embrace]]) then
--		s.SetOtherAuras(686--[[Shadow Bolt]], 32385--[[Shadow Embrace]])
--		s.SetOtherAuras(48181--[[Haunt]], 32385--[[Shadow Embrace]])
--	end
--	if s.HasTalent(18179--[[Jinx]]) then
--		s.SetOtherAuras(1490--[[Curse of the Elements]], 85547--[[Jinx: Curse of the Elements]])
--	end
end


-- Event listings:
-- http://wowprogramming.com/docs/events
-- http://www.wowwiki.com/Events_(API)

-- Add as many event functions as needed.
-- Example event function:
--function config.event.EVENT_NAME_GOES_HERE(event, ...)
--	a.print(L["Something happened!"], event, ...)
--end


config.CheckButtonOptions = {
	LeftCheckButton1 = {
		DefaultChecked = true,
		ConfigKey = "Disable_Buff",
		Label = L["Buffs"],
	},
	LeftCheckButton2 = {
		DefaultChecked = true,
		ConfigKey = "Disable_CC",
		Label = L["Polymorph"],
	},
	LeftCheckButton3 = {
		DefaultChecked = true,
		ConfigKey = "Disable_Surv",
		Label = L["Survival Mode"],
	},
	LeftCheckButton4 = {
		DefaultChecked = true,
		ConfigKey = "Disable_Mana",
		Label = L["Mana Regen"],
	},
	LeftCheckButton5 = {
		DefaultChecked = true,
		ConfigKey = "Disable_Kick",
		Label = L["Counterspell"],
	},
	LeftCheckButton6 = {
		DefaultChecked = true,
		ConfigKey = "Disable_Steal",
		Label = L["Spell Steal"],
	},
	LeftCheckButton7 = {
		DefaultChecked = false,
		ConfigKey = "Enable_Hero",
		Label = L["Mirror Images on TimeWarp Only"],
	},
	RightCheckButton1 = {
		DefaultChecked = true,
		ConfigKey = "Disable_Arcane",
		Label = L["Arcane Rotation(DPS)"],
	},
	RightCheckButton2 = {
		DefaultChecked = true,
		ConfigKey = "Disable_Fire",
		Label = L["Fire Rotation(DPS)"],
	},
	RightCheckButton3 = {
		DefaultChecked = true,
		ConfigKey = "Disable_Frost",
		Label = L["Frost Rotation(DPS)"],
	},
	RightCheckButton4 = {
		DefaultChecked = true,
		ConfigKey = "My_Config_Key",
		Label = L["My_Check_Button_Label"],
	},
	RightCheckButton5 = {
		DefaultChecked = true,
		ConfigKey = "My_Config_Key",
		Label = L["My_Check_Button_Label"],
	},
	RightCheckButton6 = {
		DefaultChecked = true,
		ConfigKey = "My_Config_Key",
		Label = L["My_Check_Button_Label"],
	},
	RightCheckButton7 = {
		DefaultChecked = true,
		ConfigKey = "My_Config_Key",
		Label = L["My_Check_Button_Label"],
	},
}


config.SlashCommands = {
	-- Add and remove as many slash commands as needed:
	"/put_slash_command_here",
	"/put_another_slash_command_here",
}

function config.SlashHandler(msg, editbox)
	local msg = msg:lower()
	-- Do something here
end


a.LoadConfigs(config)