local MinBuild, MaxBuild, Build = 40000, 0, select(4, GetBuildInfo())
if Build < MinBuild or ( MaxBuild > 0 and Build > MaxBuild ) then return end
local AddonName, a = ...
local AddonTitle = select(2, GetAddOnInfo(AddonName))
local PlainAddonTitle = AddonTitle:gsub("|c........", ""):gsub("|r", "")
local L = a.Localize
local s = SpellFlashAddon
local x = SpellFlashAddon.UpdatedVariables

local function SetColor(UseColor, Color, ElseColor)
	if UseColor then
		return Color
	end
	return ElseColor or "Pink"
end

--[[
	White - Default
	Yellow - Limited Time or No Global Cooldown
	Purple - AOE or Positional Damage
	Blue - AOE Debuff
	Orange - Finishing Move
	Aqua - Spell Interrupt, Reflect or Dispel
	Green - Self Buff or Turn Autocast On
	Red - Emergency Mitigation Cooldowns or Turn Autocast Off
	Pink - Optional
]]

-- SpellFlash API: http://wow.curseforge.com/addons/spellflash/pages/api/
-- x.Enemy, x.ActiveEnemy, x.NoCC, x.InInstance, x.InstanceType, x.PetAlive, x.PetActiveEnemy, x.PetNoCC, x.Lag, x.DoubleLag, x.ThreatPercent, x.EnemyDetected, x.ShouldPermanentBuff, x.ShouldTemporaryBuff

--Teir 13
local RadiantGloryT13LFR = {
	HeadSlot = 78788--[[Helmet of Radiant Glory]],
	ShoulderSlot = 78837--[[Pauldrons of Radiant Glory]],
	ChestSlot = 78822--[[Battleplate of Radiant Glory]],
	LegsSlot = 78807--[[Legplates of Radiant Glory]],
	HandsSlot = 78770--[[Gauntlets of Radiant Glory]],
}
local RadiantGloryT13 = {
	HeadSlot = 76876--[[Helmet of Radiant Glory]],
	ShoulderSlot = 76878--[[Pauldrons of Radiant Glory]],
	ChestSlot = 76874--[[Battleplate of Radiant Glory]],
	LegsSlot = 76877--[[Legplates of Radiant Glory]],
	HandsSlot = 78675--[[Gauntlets of Radiant Glory]],
}
local RadiantGloryT13H = {
	HeadSlot = 78693--[[Helmet of Radiant Glory]],
	ShoulderSlot = 78742--[[Pauldrons of Radiant Glory]],
	ChestSlot = 78727--[[Battleplate of Radiant Glory]],
	LegsSlot = 78712--[[Legplates of Radiant Glory]],
	HandsSlot = 76875--[[Gauntlets of Radiant Glory]],
}

local function RadiantGloryCount()
	local count = 0
	for Slot in pairs(RadiantGloryT13) do
		if s.Equipped(RadiantGloryT13LFR[Slot], Slot) or s.Equipped(RadiantGloryT13[Slot], Slot) or s.Equipped(RadiantGloryT13H[Slot], Slot) then
			count = count + 1
		end
	end
	return count
end


local function Buffs()
	if a.GetConfig("Disable_Buff") then return end
		if s.TalentMastery(1) then
			if s.Flashable(53563--[[Beacon of light]]) and a.Castable["Beacon of light"]() then
				s.Flash(53563--[[Beacon of light]], "Yellow")
			end
		end
		if IsMounted() then
			if a.Castable["Crusader Aura"]() then
				if s.Flashable(32223--[[Crusader Aura]]) then
					s.Flash(32223--[[Crusader Aura]])
				end
				s.FlashForm(32223--[[Crusader Aura]])
			end
		elseif not s.Form() or s.Form(32223--[[Crusader Aura]]) or ( ( a.Castable["Devotion Aura"]() or a.Castable["Retribution Aura"]() or a.Castable["Concentration Aura"]() or a.Castable["Resistance Aura"]() ) and s.SelfBuff(s.Form(), "raid|range|notself") ) then
			if a.Castable["Devotion Aura"]() then
				if s.Flashable(465--[[Devotion Aura]]) then
					s.Flash(465--[[Devotion Aura]])
				end
				s.FlashForm(465--[[Devotion Aura]])
			end
			if a.Castable["Retribution Aura"]() then
				if s.Flashable(7294--[[Retribution Aura]]) then
					s.Flash(7294--[[Retribution Aura]])
				end
				s.FlashForm(7294--[[Retribution Aura]])
			end
			if a.Castable["Concentration Aura"]() then
				if s.Flashable(19746--[[Concentration Aura]]) then
					s.Flash(19746--[[Concentration Aura]])
				end
				s.FlashForm(19746--[[Concentration Aura]])
			end
			if a.Castable["Resistance Aura"]() then
				if s.Flashable(19891--[[Resistance Aura]]) then
					s.Flash(19891--[[Resistance Aura]])
				end
				s.FlashForm(19891--[[Resistance Aura]])
			end
		end
	if not IsMounted() or s.InCombat() then
		if s.Flashable(20217--[[Blessing of Kings]]) and a.Castable["Blessing of Kings"]() then
			s.Flash(20217--[[Blessing of Kings]], "Green")
		elseif s.Flashable(19740--[[Blessing of Might]]) and a.Castable["Blessing of Might"]() then
			s.Flash(19740--[[Blessing of Might]], "Green")
		end
		if s.Flashable(20165--[[Seal of Insight]]) and a.Castable["Seal of Insight2"]() then
			s.Flash(20165--[[Seal of Insight]], "Green")
		end
		if s.Flashable(20164--[[Seal of Justice]]) and a.Castable["Seal of Justice2"]() then
			s.Flash(20164--[[Seal of Justice]], "Green")
		end
		if s.Flashable(20154--[[Seal of Righteousness]]) and a.Castable["Seal of Righteousness2"]() then
			s.Flash(20154--[[Seal of Righteousness]], "Green")
		end
		if s.TalentMastery(3) or s.TalentMastery(2) then
			if s.Flashable(31801--[[Seal of Truth]]) and a.Castable["Seal of Truth"]() then
				s.Flash(31801--[[Seal of Truth]], "Yellow")
			elseif s.Flashable(31801--[[Seal of Truth]]) and a.Castable["Seal of Truth2"]() then
				s.Flash(31801--[[Seal of Truth]], "Green")
			end
		elseif s.Flashable(31801--[[Seal of Truth]]) and a.Castable["Seal of Truth2"]() then
				s.Flash(31801--[[Seal of Truth]], "Green")
		end
	end
	if not IsMounted() or not s.InCombat() then
		if s.Flashable(20217--[[Blessing of Kings]]) and a.Castable["Blessing of Kings"]() then
			s.Flash(20217--[[Blessing of Kings]], "Green")
		elseif s.Flashable(19740--[[Blessing of Might]]) and a.Castable["Blessing of Might"]() then
			s.Flash(19740--[[Blessing of Might]], "Green")
		end
		if s.Flashable(20165--[[Seal of Insight]]) and a.Castable["Seal of Insight"]() then
			s.Flash(20165--[[Seal of Insight]], "Green")
		end
		if s.Flashable(20164--[[Seal of Justice]]) and a.Castable["Seal of Justice"]() then
			s.Flash(20164--[[Seal of Justice]], "Green")
		end
		if s.Flashable(20154--[[Seal of Righteousness]]) and a.Castable["Seal of Righteousness"]() then
			s.Flash(20154--[[Seal of Righteousness]], "Green")
		end
		if s.TalentMastery(3) then
			if s.Flashable(31801--[[Seal of Truth]]) and a.Castable["Seal of Truth"]() then
				s.Flash(31801--[[Seal of Truth]], "Yellow")
			end
		elseif s.Flashable(31801--[[Seal of Truth]]) and a.Castable["Seal of Truth"]() then
				s.Flash(31801--[[Seal of Truth]], "Green")
		end
	end
end



local function CrowdControl()
	if a.GetConfig("Disable_CC") then return end
	local CCUnit = nil
	if UnitExists("focus") and not s.Boss("focus") then
		CCUnit = "focus"
	end
	if s.Flashable(20066--[[Repentance]]) and a.Castable["Repentance"](CCUnit) then
		s.Flash(20066--[[Repentance]], SetColor(s.ActiveEnemy(CCUnit, 1), "Yellow"))
	end
end

local function Survival()
	if a.GetConfig("Disable_Surv") then return end
	if s.Flashable(85673--[[Word of Glory]]) and UnitPower("player", SPELL_POWER_HOLY_POWER) == 1 and s.HealthPercent("player") <= 40 and  x.NoCC and a.Castable["Word of Glory"]() then
			s.Flash(85673--[[Word of Glory]], SetColor(x.ActiveEnemy, "Red"))
		elseif s.Flashable(85673--[[Word of Glory]]) and UnitPower("player", SPELL_POWER_HOLY_POWER) == 2 and s.HealthPercent("player") <= 30 and x.NoCC and a.Castable["Word of Glory"]() then
			s.Flash(85673--[[Word of Glory]], SetColor(x.ActiveEnemy, "Red"))
		elseif s.Flashable(85673--[[Word of Glory]]) and UnitPower("player", SPELL_POWER_HOLY_POWER) == 3 and s.HealthPercent("player") <= 20 and x.NoCC and a.Castable["Word of Glory"]() then
			s.Flash(85673--[[Word of Glory]], SetColor(x.ActiveEnemy, "Red"))
	end
end

local function ManaRegen()
	if a.GetConfig("Disable_Mana") then return end
		if s.Flashable(54428--[[Divine Plea]]) and not s.TalentMastery(1) and s.PowerPercent("player") <= 50 and not s.HasTalent(31848--[[Shield of the Templar]]) and x.NoCC and a.Castable["Divine Plea"]() then
			s.Flash(54428--[[Divine Plea]], SetColor(x.ActiveEnemy, "Blue"))
		end
	if s.TalentMastery(1) then
		if s.Flashable(54428--[[Divine Plea]]) and s.PowerPercent("player") <= 80 and x.NoCC and a.Castable["Divine Plea"]() then
			s.Flash(54428--[[Divine Plea]], SetColor(x.ActiveEnemy, "Blue"))
		end
	end
end

local function Interrupts()
	if a.GetConfig("Disable_Kick") then return end
	if s.Flashable(96231--[[Rebuke]]) and x.NoCC and a.Castable["Rebuke"]() then
			s.Flash(96231--[[Rebuke]], SetColor(x.ActiveEnemy, "Aqua"))
		elseif s.Flashable(31935--[[Avenger's Shield]]) and x.NoCC and a.Castable["Avenger's Shield"](1) then
			s.Flash(31935--[[Avenger's Shield]], SetColor(x.ActiveEnemy, "Aqua"))
		elseif s.Flashable(853--[[Hammer of Justice]]) and x.NoCC and a.Castable["Hammer of Justice"]() then
			s.Flash(853--[[Hammer of Justice]], SetColor(x.ActiveEnemy, "Aqua"))
	end
end

local function HolyRotation()
	if a.GetConfig("Disable_Holy") then return end
	if s.TalentMastery(1) then
			
			
			if s.Flashable(879--[[Exorcism]]) and s.Buff(31825--[[Denounce]], "player") and a.Castable["Exorcism"]() then
				s.Flash(879--[[Exorcism]], "Yellow")
			end
			if s.Flashable(54428--[[Divine Plea]]) and s.HasTalent(31825--[[Denounce]]) and s.PowerPercent("player") <= 50 and x.NoCC and a.Castable["Divine Plea"]() then
				s.Flash(54428--[[Divine Plea]], SetColor(x.ActiveEnemy, "Blue"))
			end
			if s.Flashable(498--[[Divine Protection]]) and x.NoCC and a.Castable["Divine Protection"]() then
				s.Flash(498--[[Divine Protection]], SetColor(x.ActiveEnemy, "red"))
			end
			if s.Flashable(86150--[[Guardian of Ancient Kings]]) and s.Buff(31842--[[Divine Favor]], "player") and x.NoCC and a.Castable["Guardian of Ancient Kings"]() then
				s.Flash(86150--[[Guardian of Ancient Kings]], SetColor(x.ActiveEnemy, "Green"))
			end
			
			if s.Buff(53672--[[Infusion of Light]], "player") then
				if s.Flashable(635--[[Holy Light]]) and a.Castable["Holy Light"]() then
					s.Flash(635--[[Holy Light]], "Green")
				end
				if s.Flashable(82326--[[Divine Light]]) and a.Castable["Divine Light"]() then
					s.Flash(82326--[[Divine Light]], "Green")
				end
				if s.Flashable(19750--[[Flash of Light]]) and a.Castable["Flash of Light"]() then
					s.Flash(19750--[[Flash of Light]], "Green")
				end
			end
			if s.Buff(88820--[[Daybreak]], "player") then
				if s.Flashable(20473--[[Holy Shock]]) and a.Castable["Holy Shock"]() then
					s.Flash(20473--[[Holy Shock]], "Green")
				end
			end
				
			
			if s.Flashable(20271--[[Judgement]]) and s.HasTalent(53671--[[Judgements of the Pure]]) and s.MyBuffDuration(53671--[[Judgements of the Pure]], "player") <= 5 and a.Castable["Judgement"]() then
				s.Flash(20271--[[Judgement]], "Aqua")
			end
			if s.HasTalent(31825--[[Denounce]]) then
				if s.Flashable(84963--[[Inquisition]]) and UnitPower("player", SPELL_POWER_HOLY_POWER) == 3 and not s.Buff(84963--[[Inquisition]], "player") and x.NoCC and a.Castable["Inquisition"]() then
					s.Flash(84963--[[Inquisition]], SetColor(x.ActiveEnemy, "Green"))
				end
				if s.Flashable(20473--[[Holy Shock]]) and not s.Buff(31842--[[Divine Favor]], "player") and a.Castable["Holy Shock"]() then
					s.Flash(20473--[[Holy Shock]], "White")
				elseif s.Flashable(31842--[[Divine Favor]]) and s.Boss("target") and a.Castable["Divine Favor"]() then
					s.Flash(31842--[[Divine Favor]], "Yellow")
				elseif s.Flashable(31884--[[Avenging Wrath]]) and s.Boss("target") and a.Castable["Avenging Wrath"]() then
					s.Flash(31884--[[Avenging Wrath]], "Yellow")
				elseif s.Flashable(879--[[Exorcism]]) and s.Buff(53671--[[Judgements of the Pure]], "player") and a.Castable["Exorcism"]() then
					s.Flash(879--[[Exorcism]], "White")
				end
			end
		end
end

local function ProtRotation()
	if a.GetConfig("Disable_Prot") then return end
	if s.TalentMastery(2) then -- Protection Spec
			
			if s.Flashable(25780--[[Righteous Fury]]) and a.Castable["Righteous Fury"]() then
				s.Flash(25780--[[Righteous Fury]], "Green")
			end
			
			if s.Flashable(20925--[[Holy Shield]]) and x.NoCC and a.Castable["Holy Shield"]() then
				s.Flash(20925--[[Holy Shield]], SetColor(x.ActiveEnemy, "Yellow"))
			end
			
			if x.ThreatPercent <= 95 then
				if s.Flashable(62124--[[Hand of Reckoning]]) and a.Castable["Hand of Reckoning"]() then
					s.Flash(62124--[[Hand of Reckoning]], SetColor(x.ActiveEnemy, "Purple"))
				end
			end
			
			if s.Flashable(31850--[[Ardent Defender]]) and x.NoCC and a.Castable["Ardent Defender"]() then
				s.Flash(31850--[[Ardent Defender]], SetColor(x.ActiveEnemy, "Red"))
			elseif s.Flashable(70940--[[Divine Guardian]]) and x.NoCC and a.Castable["Divine Guardian"]() then
				s.Flash(70940--[[Divine Guardian]], SetColor(x.ActiveEnemy, "Red"))
			elseif s.Flashable(498--[[Divine Protection]]) and not s.Buff(31850--[[Ardent Defender]], "player") and x.NoCC and a.Castable["Divine Protection"]() then
				s.Flash(498--[[Divine Protection]], SetColor(x.ActiveEnemy, "Red"))
			elseif s.Flashable(86150--[[Guardian of Ancient Kings]]) and s.EnemyTargetingYou("player") and s.HealthPercent("player") <= 35 and x.NoCC and a.Castable["Guardian of Ancient Kings"]() then
				s.Flash(86150--[[Guardian of Ancient Kings]], SetColor(x.ActiveEnemy, "Red"))
			end
			
			
		if not a.AOE then --Single Target
					
			if s.Flashable(53600--[[Shield of the Righteous]]) and UnitPower("player", SPELL_POWER_HOLY_POWER) == 3 and x.NoCC and a.Castable["Shield of the Righteous"]() then
				s.Flash(53600--[[Shield of the Righteous]], SetColor(x.ActiveEnemy, "Yellow"))
			end
			
			if s.Flashable(85673--[[Word of Glory]]) and UnitPower("player", SPELL_POWER_HOLY_POWER) == 3 and x.NoCC and a.Castable["Word of Glory"]() then
				s.Flash(85673--[[Word of Glory]], SetColor(x.ActiveEnemy, "Red"))
			end
			
			if s.Flashable(54428--[[Divine Plea]]) and s.InCombat and s.HasTalent(31848--[[Shield of the Templar]]) and s.Buff(31884--[[Avenging Wrath]], "player") and UnitPower("player", SPELL_POWER_HOLY_POWER) == 0 and x.NoCC and a.Castable["Divine Plea"]() then
				s.Flash(54428--[[Divine Plea]], SetColor(x.ActiveEnemy, "Yellow"))
			elseif s.Flashable(31884--[[Avenging Wrath]]) and UnitPower("player", SPELL_POWER_HOLY_POWER) == 3 and x.NoCC and a.Castable["Avenging Wrath"]() then
				s.Flash(31884--[[Avenging Wrath]], SetColor(x.ActiveEnemy, "Yellow"))
			end
			
			if s.Flashable(35395--[[Crusader Strike]]) and x.NoCC and a.Castable["Crusader Strike"]() then
				s.Flash(35395--[[Crusader Strike]], SetColor(x.ActiveEnemy))
			elseif s.Flashable(20271--[[Judgement]]) and x.NoCC and a.Castable["Judgement"]() then
				s.Flash(20271--[[Judgement]], SetColor(x.ActiveEnemy))
			elseif s.Flashable(24275--[[Hammer of Wrath]]) and s.HealthPercent("target") < 20 and x.NoCC and a.Castable["Hammer of Wrath"]() then
				s.Flash(24275--[[Hammer of Wrath]], SetColor(x.ActiveEnemy, "Yellow"))
			elseif s.Flashable(31935--[[Avenger's Shield]]) and x.NoCC and a.Castable["Avenger's Shield"]() then
				s.Flash(31935--[[Avenger's Shield]], SetColor(x.ActiveEnemy))			
			elseif s.Flashable(26573--[[Consecration]]) and x.NoCC and a.Castable["Consecration"]() then
				s.Flash(26573--[[Consecration]], SetColor(x.ActiveEnemy))
			elseif s.Flashable(2812--[[Holy Wrath]]) and x.NoCC and a.Castable["Holy Wrath"]() then
				s.Flash(2812--[[Holy Wrath]], SetColor(x.ActiveEnemy))
			end
		end

		if a.AOE then --Multiple Target
			
			if s.Flashable(85673--[[Word of Glory]]) and UnitPower("player", SPELL_POWER_HOLY_POWER) == 3 and x.NoCC and a.Castable["Word of Glory"]() then
				s.Flash(85673--[[Word of Glory]], SetColor(x.ActiveEnemy, "Red"))
			end
			
			if s.Flashable(53595--[[Hammer of the Righteous]]) and x.NoCC and a.Castable["Hammer of the Righteous"]() then
				s.Flash(53595--[[Hammer of the Righteous]], SetColor(x.ActiveEnemy))
			elseif s.Flashable(26573--[[Consecration]]) and x.NoCC and a.Castable["Consecration"]() then
				s.Flash(26573--[[Consecration]], SetColor(x.ActiveEnemy))
			elseif s.Flashable(2812--[[Holy Wrath]]) and x.NoCC and a.Castable["Holy Wrath"]() then
				s.Flash(2812--[[Holy Wrath]], SetColor(x.ActiveEnemy))
			elseif s.Flashable(31935--[[Avenger's Shield]]) and x.NoCC and a.Castable["Avenger's Shield"]() then
				s.Flash(31935--[[Avenger's Shield]], SetColor(x.ActiveEnemy))
			elseif s.Flashable(84963--[[Inquisition]]) and UnitPower("player", SPELL_POWER_HOLY_POWER) >= 1 and x.NoCC and a.Castable["Inquisition"]() then
				s.Flash(84963--[[Inquisition]], SetColor(x.ActiveEnemy, "Yellow"))
			elseif s.Flashable(53600--[[Shield of the Righteous]]) and UnitPower("player", SPELL_POWER_HOLY_POWER) >= 1 and x.NoCC and a.Castable["Shield of the Righteous"]() then
				s.Flash(53600--[[Shield of the Righteous]], SetColor(x.ActiveEnemy, "Yellow"))
			elseif s.Flashable(20271--[[Judgement]]) and x.NoCC and a.Castable["Judgement"]() then
				s.Flash(20271--[[Judgement]], SetColor(x.ActiveEnemy))
			elseif s.Flashable(24275--[[Hammer of Wrath]]) and s.HealthPercent("target") < 20 and x.NoCC and a.Castable["Hammer of Wrath"]() then
				s.Flash(24275--[[Hammer of Wrath]], SetColor(x.ActiveEnemy, "Yellow"))
			end
		end
	end
end

local function RetRotation()
	if a.GetConfig("Disable_Ret") then return end
	if s.TalentMastery(3) then -- Ret Spec
	
		-- Tier piece sets
		local RadiantGloryPieces = RadiantGloryCount()
		local FourRadiantGloryPieces = RadiantGloryPieces >= 4
		local TwoRadiantGloryPieces = RadiantGloryPieces >= 2
		
				if s.Buff(32182--[[Heroism]], "player") or s.Buff(2825--[[Bloodlust]], "player") or s.Buff(80353--[[Time Warp]], "player") then
					if s.Flashable(s.ItemName(58146--[[Golemblood Potion]])) and x.NoCC and a.ItemCastable["Golemblood Potion"]() then
						s.Flash(s.ItemName(58146--[[Golemblood Potion]], SetColor(x.ActiveEnemy, "Green")))
					end
				end
			
			if s.Flashable(86150--[[Guardian of Ancient Kings]]) and s.Boss("target") and s.MyBuff(84963--[[Inquisition]], "player") and x.NoCC and a.Castable["Guardian of Ancient Kings"]() then
				s.Flash(86150--[[Guardian of Ancient Kings]], SetColor(x.ActiveEnemy, "Green"))
			elseif s.Flashable(85696--[[Zealotry]]) and s.Power("player", SPELL_POWER_HOLY_POWER) == 3 and not s.Buff(90174--[[Divine Purpose]], "player") and x.NoCC and a.Castable["Zealotry"]() then
				s.Flash(85696--[[Zealotry]], SetColor(x.ActiveEnemy, "Yellow"))
			end
			if s.Flashable(31884--[[Avenging Wrath]]) and s.Buff(85696--[[Zealotry]], "player") and x.NoCC and a.Castable["Avenging Wrath"]() then
				s.Flash(31884--[[Avenging Wrath]], SetColor(x.ActiveEnemy, "Yellow"))
			end
			
		if (s.Buff(85696--[[Zealotry]], "player") or s.Buff(31884--[[Avenging Wrath]], "player")) and not (s.Race(nil, "undead") or s.Race(nil, "demon")) then --Sample rotation, AW/Zealotry up, non-UD/Demon target:
		--CS3 > TV > HoW > CS3 > TV > Exo > CS3 > TV > J > CS3 > TV > HoW ... etc.
			if s.Flashable(84963--[[Inquisition]]) and UnitPower("player", SPELL_POWER_HOLY_POWER) >= 3 and s.BuffDuration(84963--[[Inquisition]], nil, 3) and x.NoCC and a.Castable["Inquisition"]() then
				s.Flash(84963--[[Inquisition]], SetColor(x.ActiveEnemy, "Green"))
			elseif s.Flashable(85256--[[Templar's Verdict]]) and s.Buff(90174--[[Divine Purpose]], "player") and x.NoCC and a.Castable["Templar's Verdict"]() then
				s.Flash(85256--[[Templar's Verdict]], SetColor(x.ActiveEnemy, "Yellow"))
			elseif s.Flashable(85256--[[Templar's Verdict]]) and s.Power("player", SPELL_POWER_HOLY_POWER) == 3 and x.NoCC and a.Castable["Templar's Verdict"]() then
				s.Flash(85256--[[Templar's Verdict]], SetColor(x.ActiveEnemy))
			elseif s.Flashable(24275--[[Hammer of Wrath]]) and s.SpellCooldown(35395--[[Crusader Strike]], "player") > 1.5 and x.NoCC and a.Castable["Hammer of Wrath"]() then
				s.Flash(24275--[[Hammer of Wrath]], SetColor(x.ActiveEnemy, "Yellow"))
			elseif s.Flashable(35395--[[Crusader Strike]]) and s.Power("player", SPELL_POWER_HOLY_POWER) <= 2 and x.NoCC and a.Castable["Crusader Strike"]() then
					s.Flash(35395--[[Crusader Strike]], SetColor(x.ActiveEnemy, "White"))
			elseif s.Flashable(20271--[[Judgement]]) and s.SpellCooldown(35395--[[Crusader Strike]], "player") > 1.5 and x.NoCC and a.Castable["Judgement"]() then
					s.Flash(20271--[[Judgement]], SetColor(x.ActiveEnemy, "White"))
			end
		end
		
		if (s.Buff(85696--[[Zealotry]], "player") or s.Buff(31884--[[Avenging Wrath]], "player")) and not (s.Race(nil, "undead") or s.Race(nil, "demon")) and (s.Buff(80353--[[Time Warp]], "player") or s.Buff(32182--[[Heroism]], "player") or s.Buff(2825--[[Bloodlust]], "player")) then --Sample, AW/Zealotry up, non-UD/Demon + Bloodlust effect:
		--CS3 > TV > CS3 > TV > CS3 > TV > CS3 > TV ... etc.
			if s.Flashable(84963--[[Inquisition]]) and UnitPower("player", SPELL_POWER_HOLY_POWER) >= 3 and s.BuffDuration(84963--[[Inquisition]], nil, 3) and x.NoCC and a.Castable["Inquisition"]() then
				s.Flash(84963--[[Inquisition]], SetColor(x.ActiveEnemy, "Green"))
			elseif s.Flashable(85256--[[Templar's Verdict]]) and s.Buff(90174--[[Divine Purpose]], "player") and x.NoCC and a.Castable["Templar's Verdict"]() then
				s.Flash(85256--[[Templar's Verdict]], SetColor(x.ActiveEnemy, "Yellow"))
			elseif s.Flashable(85256--[[Templar's Verdict]]) and s.Power("player", SPELL_POWER_HOLY_POWER) == 3 and x.NoCC and a.Castable["Templar's Verdict"]() then
				s.Flash(85256--[[Templar's Verdict]], SetColor(x.ActiveEnemy))
			elseif s.Flashable(35395--[[Crusader Strike]]) and s.Power("player", SPELL_POWER_HOLY_POWER) <= 2 and x.NoCC and a.Castable["Crusader Strike"]() then
					s.Flash(35395--[[Crusader Strike]], SetColor(x.ActiveEnemy, "White"))
			end
		end
		
		if (s.Buff(85696--[[Zealotry]], "player") or s.Buff(31884--[[Avenging Wrath]], "player")) and (s.Race(nil, "undead") or s.Race(nil, "demon")) and (s.Buff(80353--[[Time Warp]], "player") or s.Buff(32182--[[Heroism]], "player") or s.Buff(2825--[[Bloodlust]], "player")) then --Sample, AW/Zealotry up, vs UD/Demon + Bloodlust effect:
		--CS3 > Exo > TV > CS3 > TV > CS3 > TV > CS3 > Exo > TV ... etc.
			if s.Flashable(84963--[[Inquisition]]) and UnitPower("player", SPELL_POWER_HOLY_POWER) >= 3 and s.BuffDuration(84963--[[Inquisition]], nil, 3) and x.NoCC and a.Castable["Inquisition"]() then
				s.Flash(84963--[[Inquisition]], SetColor(x.ActiveEnemy, "Green"))
			elseif s.Flashable(879--[[Exorcism]]) and s.Buff(59578--[[The Art of War]], "player") and x.NoCC and a.Castable["Exorcism"]() then
					s.Flash(879--[[Exorcism]], SetColor(x.ActiveEnemy, "Yellow"))
			elseif s.Flashable(85256--[[Templar's Verdict]]) and s.Buff(90174--[[Divine Purpose]], "player") and x.NoCC and a.Castable["Templar's Verdict"]() then
				s.Flash(85256--[[Templar's Verdict]], SetColor(x.ActiveEnemy, "Yellow"))
			elseif s.Flashable(85256--[[Templar's Verdict]]) and s.Power("player", SPELL_POWER_HOLY_POWER) == 3 and x.NoCC and a.Castable["Templar's Verdict"]() then
				s.Flash(85256--[[Templar's Verdict]], SetColor(x.ActiveEnemy))
			elseif s.Flashable(35395--[[Crusader Strike]]) and s.Power("player", SPELL_POWER_HOLY_POWER) <= 2 and x.NoCC and a.Castable["Crusader Strike"]() then
					s.Flash(35395--[[Crusader Strike]], SetColor(x.ActiveEnemy, "White"))
			end
		end
		
		if (s.Buff(85696--[[Zealotry]], "player") or s.Buff(31884--[[Avenging Wrath]], "player")) and (s.Race(nil, "undead") or s.Race(nil, "demon")) then --Sample, AW/Zealotry up, vs UD/Demon:
		--CS3 > Exo > TV > CS3 > TV > CS3 > TV > CS3 > Exo > TV ... etc.
			if s.Flashable(84963--[[Inquisition]]) and UnitPower("player", SPELL_POWER_HOLY_POWER) >= 3 and s.BuffDuration(84963--[[Inquisition]], nil, 3) and x.NoCC and a.Castable["Inquisition"]() then
				s.Flash(84963--[[Inquisition]], SetColor(x.ActiveEnemy, "Green"))
			elseif s.Flashable(879--[[Exorcism]]) and s.Buff(59578--[[The Art of War]], "player") and x.NoCC and a.Castable["Exorcism"]() then
					s.Flash(879--[[Exorcism]], SetColor(x.ActiveEnemy, "Yellow"))
			elseif s.Flashable(85256--[[Templar's Verdict]]) and s.Buff(90174--[[Divine Purpose]], "player") and x.NoCC and a.Castable["Templar's Verdict"]() then
				s.Flash(85256--[[Templar's Verdict]], SetColor(x.ActiveEnemy, "Yellow"))
			elseif s.Flashable(85256--[[Templar's Verdict]]) and s.Power("player", SPELL_POWER_HOLY_POWER) == 3 and x.NoCC and a.Castable["Templar's Verdict"]() then
				s.Flash(85256--[[Templar's Verdict]], SetColor(x.ActiveEnemy))
			elseif s.Flashable(35395--[[Crusader Strike]]) and s.Power("player", SPELL_POWER_HOLY_POWER) <= 2 and x.NoCC and a.Castable["Crusader Strike"]() then
					s.Flash(35395--[[Crusader Strike]], SetColor(x.ActiveEnemy, "White"))
			end
		end
			
		if not TwoRadiantGloryPieces and not (s.Buff(85696--[[Zealotry]], "player") or s.Buff(31884--[[Avenging Wrath]], "player")) then --Single Target regular rotation
			if s.Flashable(24275--[[Hammer of Wrath]]) and x.NoCC and a.Castable["Hammer of Wrath"]() then
				s.Flash(24275--[[Hammer of Wrath]], SetColor(x.ActiveEnemy, "Yellow"))
			elseif s.Flashable(84963--[[Inquisition]]) and UnitPower("player", SPELL_POWER_HOLY_POWER) >= 2 and s.BuffDuration(84963--[[Inquisition]], nil, 3) and x.NoCC and a.Castable["Inquisition"]() then
				s.Flash(84963--[[Inquisition]], SetColor(x.ActiveEnemy, "Green"))
			elseif s.Flashable(85256--[[Templar's Verdict]]) and s.Buff(90174--[[Divine Purpose]], "player") and x.NoCC and a.Castable["Templar's Verdict"]() then
				s.Flash(85256--[[Templar's Verdict]], SetColor(x.ActiveEnemy, "Yellow"))
			elseif s.Flashable(85256--[[Templar's Verdict]]) and s.Power("player", SPELL_POWER_HOLY_POWER) == 3 and x.NoCC and a.Castable["Templar's Verdict"]() then
				s.Flash(85256--[[Templar's Verdict]], SetColor(x.ActiveEnemy))
			else
				if s.Flashable(35395--[[Crusader Strike]]) and s.Power("player", SPELL_POWER_HOLY_POWER) <= 2 and x.NoCC and a.Castable["Crusader Strike"]() then
					s.Flash(35395--[[Crusader Strike]], SetColor(x.ActiveEnemy, "White"))
				elseif s.Flashable(879--[[Exorcism]]) and s.Buff(59578--[[The Art of War]], "player") and s.SpellCooldown(35395--[[Crusader Strike]], "player") > 1.5 and x.NoCC and a.Castable["Exorcism"]() then
					s.Flash(879--[[Exorcism]], SetColor(x.ActiveEnemy, "Yellow"))
				elseif s.Flashable(20271--[[Judgement]]) and x.NoCC and s.SpellCooldown(35395--[[Crusader Strike]], "player") > 1.5 and a.Castable["Judgement"]() then
					s.Flash(20271--[[Judgement]], SetColor(x.ActiveEnemy, "White"))
				elseif s.Flashable(2812--[[Holy Wrath]]) and x.NoCC and s.SpellCooldown(35395--[[Crusader Strike]], "player") > 1.5 and a.Castable["Holy Wrath"]() then
					s.Flash(2812--[[Holy Wrath]], SetColor(x.ActiveEnemy))
				elseif s.Flashable(26573--[[Consecration]]) and s.PowerPercent("player") >= 80 and s.SpellCooldown(35395--[[Crusader Strike]], "player") > 2 and s.SpellCooldown(20271--[[Judgement]], "player") > 2 and x.NoCC and a.Castable["Consecration"]() then
					s.Flash(26573--[[Consecration]], SetColor(x.ActiveEnemy))
				end
			end
		end
		-- T13 ROTATION
		
		if TwoRadiantGloryPieces and not (s.Buff(85696--[[Zealotry]], "player") or s.Buff(31884--[[Avenging Wrath]], "player")) then --Single Target regular rotation
			if s.Flashable(24275--[[Hammer of Wrath]]) and x.NoCC and a.Castable["Hammer of Wrath"]() then
				s.Flash(24275--[[Hammer of Wrath]], SetColor(x.ActiveEnemy, "Yellow"))
			elseif s.Flashable(84963--[[Inquisition]]) and UnitPower("player", SPELL_POWER_HOLY_POWER) >= 2 and s.BuffDuration(84963--[[Inquisition]], nil, 3) and x.NoCC and a.Castable["Inquisition"]() then
				s.Flash(84963--[[Inquisition]], SetColor(x.ActiveEnemy, "Green"))
			elseif s.Flashable(85256--[[Templar's Verdict]]) and s.Buff(90174--[[Divine Purpose]], "player") and x.NoCC and a.Castable["Templar's Verdict"]() then
				s.Flash(85256--[[Templar's Verdict]], SetColor(x.ActiveEnemy, "Yellow"))
			elseif s.Flashable(85256--[[Templar's Verdict]]) and s.Power("player", SPELL_POWER_HOLY_POWER) == 3 and x.NoCC and a.Castable["Templar's Verdict"]() then
				s.Flash(85256--[[Templar's Verdict]], SetColor(x.ActiveEnemy))
			else
				if s.Flashable(35395--[[Crusader Strike]]) and s.Power("player", SPELL_POWER_HOLY_POWER) <= 2 and x.NoCC and a.Castable["Crusader Strike"]() then
					s.Flash(35395--[[Crusader Strike]], SetColor(x.ActiveEnemy, "White"))
				elseif s.Flashable(20271--[[Judgement]]) and x.NoCC and s.SpellCooldown(35395--[[Crusader Strike]], "player") > 1.5 and a.Castable["Judgement"]() then
					s.Flash(20271--[[Judgement]], SetColor(x.ActiveEnemy, "White"))
				elseif s.Flashable(879--[[Exorcism]]) and s.Buff(59578--[[The Art of War]], "player") and s.SpellCooldown(35395--[[Crusader Strike]], "player") > 1.5 and x.NoCC and a.Castable["Exorcism"]() then
					s.Flash(879--[[Exorcism]], SetColor(x.ActiveEnemy, "Yellow"))
				elseif s.Flashable(2812--[[Holy Wrath]]) and x.NoCC and s.SpellCooldown(35395--[[Crusader Strike]], "player") > 1.5 and a.Castable["Holy Wrath"]() then
					s.Flash(2812--[[Holy Wrath]], SetColor(x.ActiveEnemy))
				elseif s.Flashable(26573--[[Consecration]]) and s.PowerPercent("player") >= 80 and s.SpellCooldown(35395--[[Crusader Strike]], "player") > 2 and s.SpellCooldown(20271--[[Judgement]], "player") > 2 and x.NoCC and a.Castable["Consecration"]() then
					s.Flash(26573--[[Consecration]], SetColor(x.ActiveEnemy))
				end
			end
		end
		if a.AOE then --Single Target
			
		end
	end
end




-- Use this single spam function and remove the multiple spam table below, or just use the multiple spam table below and leave this function in place.
s.Spam[AddonName] = function() if a.GetConfig("spell_flashing_off") then return end a.RunSpamTable()
	
		Buffs()
		Interrupts()
		ManaRegen()
		Survival()
		CrowdControl()
		RetRotation()
		ProtRotation()
		HolyRotation()
	
end