local AddonName, a = ...
if a.BuildFail(40000, 50000) then return end
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables

-- SpellFlash API:
-- http://wow.curseforge.com/addons/spellflash/pages/api/

-- Updated variable references:
-- http://wow.curseforge.com/addons/spellflash/pages/api/#w-local-x-spell-flash-addon-updated-variables
-- x.Enemy, x.ActiveEnemy, x.NoCC, x.InInstance, x.InstanceType, x.PetAlive, x.PetActiveEnemy, x.PetNoCC, x.Lag, x.DoubleLag, x.ThreatPercent, x.EnemyDetected, x.ShouldPermanentBuff, x.ShouldTemporaryBuff

-- Spell table references:
-- http://wow.curseforge.com/addons/spellflash/pages/api/#w-s-castable


a.spells["Every Man for Himself"] = {
	ID = 59752--[[Every Man for Himself]],
	FlashColor = "Aqua",
	CheckFirst = function(z)
		return s.CrowedControlled("player") or s.MovementImpaired("player")
	end,
}

a.spells["Will of the Forsaken"] = {
	ID = 7744--[[Will of the Forsaken]],
	FlashColor = "Aqua",
	CheckFirst = function(z)
		return s.CrowedControlled("player")
	end,
}

a.spells["Stoneform"] = {
	ID = 20594--[[Stoneform]],
	FlashColor = "Aqua",
	CheckFirst = function(z)
		return s.Diseased("player") or s.Poisoned("player")
	end,
}

a.spells["Arcane Torrent"] = {
	ID = 28730--[[Arcane Torrent]],
	EnemyTargetNeeded = 1,
	Melee = 1,
	Interrupt = 1,
	FlashColor = "Aqua",
}

a.spells["Berserking"] = {
	ID = 26297--[[Berserking]],
	EnemyTargetNeeded = 1,
	FlashColor = "Green",
	CheckFirst = function(z)
		return x.ActiveEnemy and s.InCombat() and ( s.HealthPercent() > 25 or UnitIsPlayer(s.UnitSelection()) or s.Boss() )
	end,
}

a.spells["Blood Fury"] = {
	ID = 20572--[[Blood Fury]],
	EnemyTargetNeeded = 1,
	FlashColor = "Green",
	CheckFirst = function(z)
		return x.ActiveEnemy and s.InCombat() and ( s.HealthPercent() > 25 or UnitIsPlayer(s.UnitSelection()) or s.Boss() )
	end,
}

a.spells["Escape Artist"] = {
	ID = 20589--[[Escape Artist]],
	FlashColor = "Aqua",
	CheckFirst = function(z)
		return s.MovementImpaired("player")
	end,
}

a.spells["War Stomp"] = {
	ID = 20549--[[War Stomp]],
	EnemyTargetNeeded = 1,
	Melee = 1,
	Interrupt = 1,
	FlashColor = "Aqua",
}

a.spells["Rocket Barrage"] = {
	ID = 69041--[[Rocket Barrage]],
	EnemyTargetNeeded = 1,
	CheckFirst = function(z)
		z.FlashColor = s.If(x.ActiveEnemy, "White", "Pink")
		return s.HealthPercent() > 25 or UnitIsPlayer(s.UnitSelection()) or s.Boss()
	end,
}

